//**************************************************************************************************
//*  FRIDA: fast reliable interactive data analysis                         
//*  (C) Joachim Wuttke 2001-                                               
//*  http://apps.jcns.fz-juelich.de/frida                                   
//**************************************************************************************************

//! \file  geni.hpp
//! \brief Collection NGeni of generalized integral wrappers CGeni.


//!  Function type: Evaluate generalized integral for given vector(s).

typedef void (*geni_eval) (double*, double*, int, const vector<RObjVecNum>& );


//! A wrapper holding a functional.

class CGeni {
 public:
    string name;
    int narg;
    string default_arg_str;
    geni_eval eval;
    string unit_hint;
    string com;
    vector<RNode> default_arg;
    class CCoord coord( class CCoord *co ) const;
    class CCoord coord( class CCoord *co1, class CCoord *co2 ) const;
    CGeni( string _txt, int _narg, string _default_arg_str, geni_eval _eval,
           string _unit_hint, string _com="" );
    void register_me() const;
};


//! Collection of function wrappers CFunc

namespace NGeni { // public (short) interface
    void initialize();
    const CGeni* find( string nam );
    void display_genis();
}
